chiark / gitweb /
setup, bin/aspell-hack, dot/emacs: Make `aspell' start in $HOME.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
8ba15f37 13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
a3bdb4d9 132 emacs emacs-calc vm gnus.el
b0d8acbe 133 vimrc mg zile
b3468c3b 134 mailrc signature
ce178f96 135 cgrc tigrc
e7d23024 136 gdbinit
8a7e906d 137 guile
5d25e440 138 toprc
cbffcf2b 139 aspell.conf
ccaac00b
MW
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
f6335a0c 143 lisp-init.lisp:.eclrc
b5bf3445 144 swank.lisp
2425eca9 145 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 146[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 147 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 148 fonts.conf
e517857c 149 stalonetrayrc
1c6b19d4 150 putty-defaults:.putty/sessions/Default%20Settings
7cfa1f1a 151 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 152 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 153 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 154 e16-bindings:.e16/bindings.cfg"
f617db13
MW
155echo "Installing dotfiles..."
156for d in $dotfiles; do
739bccbf
MW
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
99063107 164 ln -s $here/dot/$d $ft.new
739bccbf
MW
165 mv $ft.new $ft
166 echo " $target"
f617db13 167done
852cd5fb 168echo " all done."
f617db13 169
f4e43257 170## Symlink backgrounds.
960af1a5
MW
171backgrounds="
172 jue-peek.jpg
173 medusa.jpg
5236501e 174 bsg-supper.jpg
960af1a5 175 rayne.jpg
56c871ef 176 hypatia.jpg
e1ca556b
MW
177 noodly.jpg
178 lovelace.jpg"
f4e43257
MW
179if [ "$xstuff" ]; then
180 echo "Installing backgrounds..."
181 for b in $backgrounds; do
182 for e in enlightenment e16; do
183 dir=$HOME$sub/.$e/backgrounds
184 t=$dir/$b
185 mkdir -p $dir
99063107 186 ln -s $here/bg/$b $t.new
f4e43257
MW
187 mv $t.new $t
188 done
189 echo " $b"
190 done
191 echo " all done."
192fi
193
ce178f96
MW
194###--------------------------------------------------------------------------
195### Process the Git configuration.
196
197echo -n "Installing Git configuration:"
198sed "
1991i\
15581433 200### generated by $here/setup; do not edit!\
ce178f96 201
99063107
MW
202/@releasekey@/ s::$(bin/mdw-conf release-key 481334C2):g
203/@gitignore@/ s::$(bin/mdw-conf gitignore $here/git/gitignore):g
204" git/gitconfig >$HOME/.gitconfig.new
ce178f96
MW
205mv $HOME/.gitconfig.new $HOME/.gitconfig
206echo " done."
207
208###--------------------------------------------------------------------------
209### Install useful scripts included in this package.
210
e04c4857 211scripts="
547fb8af 212 mdw-editor
b20bfd83 213 mdw-pager
b056f5c4 214 mdw-conf
7ee12623 215 mdw-build
c4e84cb1 216 emacsclient-hack
8e08f814 217 movemail-hack
68b2e9e6 218 aspell-hack
285a1386
MW
219 emerge-hack
220 lesspipe.sh
221 start-ssh-agent
4cdeb0d0
MW
222 svnwrap
223 hyperspec"
8e08f814 224[ "$xstuff" ] && scripts="$scripts
3bdada49 225 xinitcmd
34a5ea4e 226 un-backslashify-selection
c02999e8 227 lock-screen
8e08f814 228 xshutdown"
e04c4857
MW
229echo "Installing scripts..."
230mkdir -p $HOME$sub/bin
231for s in $scripts; do
232 ft=$HOME$sub/bin/$s
99063107 233 ln -s $here/bin/$s $ft.new
e04c4857
MW
234 mv $ft.new $ft
235 echo " $s"
236done
237echo " all done."
238
ce178f96
MW
239###--------------------------------------------------------------------------
240### Set up the Emacs config.
241
65ff0e8c
MW
242$echon "Finding a suitable emacs:$echoc"
243emacs=no
5fe24792 244for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
245 if type -p >/dev/null $i; then
246 emacs=$i
247 break
248 fi
249done
250if [ $emacs = no ]; then
251 echo " failed."
252 emacs=:
253else
254 echo " $emacs."
255fi
256
f617db13 257echo "Installing Emacs packages..."
400223a1
MW
258emacspkg="
259 make-regexp
a1293ade 260 ew-hols
a3bdb4d9 261 mdw-gnus-patch
1778b496 262 git git-blame vc-git stgit
400223a1
MW
263 quilt"
264for elib in $emacspkg; do
f617db13 265 $echon " $elib:$echoc"
65ff0e8c 266 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 267 (progn
852cd5fb
MW
268 (setq load-path (nconc load-path (list "~/lib/emacs")))
269 (kill-emacs (condition-case nil
270 (progn (load-library "'"$elib"'") 0)
20eb0692 271 (error 1))))'; then
f617db13
MW
272 echo " already installed."
273 else
99063107
MW
274 if [ -f el/$elib.el ]; then
275 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
276 else
277 $echon " downloading$echoc"
278 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
279 fi
f617db13
MW
280 $echon " compiling$echoc"
281 (cd $HOME$sub/lib/emacs;
65ff0e8c 282 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 283 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
284 echo " done."
285 fi
286done
852cd5fb 287echo " all done."
f617db13
MW
288
289$echon "Setting up Emacs configuration:$echoc"
290$echon " linking$echoc"
99063107 291for f in dot-emacs.el Makefile; do
f617db13 292 set -- $(echo $link | tr : ' ')
99063107
MW
293 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
294 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
295done
296$echon " compiling$echoc"
65ff0e8c 297make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 298echo " done."
ce178f96
MW
299
300###----- That's all, folks --------------------------------------------------